#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "imagefile.h"

// for pgm file
int
save_pgm_file(int *img, char *filename, int width, int height)
{
   FILE		*fp;
   int		x;

   if ((fp = fopen(filename, "w")) == NULL) /* եΥץ */
      return -1;

   fprintf(fp, "P5\n");	/* ޥåʥС */
   fprintf(fp, "# generated by pgmutil.c\n");	/*  */
   fprintf(fp, "%d %d\n", width, height);	/*  */
   fprintf(fp, "255\n");		/* ٥ */

   for (x = 0; x < width * height; x++)
      fputc((0x00ff & img[x]), fp);

   fclose(fp);
   return 0;
}

int
load_pgm_file(int **img, char *filename, int *width, int *height)
{
   FILE		*fp;
   char		buff[BUFSIZ], magic[BUFSIZ];
   int		maxlevel, x;

   fp = fopen(filename, "r");
   if (fp == NULL)
      return -1;

   fgets(buff, BUFSIZ, fp);
   sscanf(buff, "%s", magic);

   if (strncmp(magic, "P5", 2))
   {
      fprintf(stderr, "Error: %s is not raw pgm format!\n", filename);
      exit(1);
   }

   fgets(buff, BUFSIZ, fp);
   while (buff[0] == '#')
      fgets(buff, BUFSIZ, fp);

   sscanf(buff, "%d %d", width, height);

   fgets(buff, BUFSIZ, fp);
   while (buff[0] == '#')
      fgets(buff, BUFSIZ, fp);
   sscanf(buff, "%d", &maxlevel);

   (*img) = new int [(*width) * (*height)];
   
   for (x = 0; x < (*width) * (*height); x++)
      (*img)[x] = 0x00ff & fgetc(fp);

   fclose(fp);

   return 0;
}

// for ppm file
int
save_ppm_file(int *img, char *filename, int width, int height)
{
   FILE		*fp;
   int		x;

   if ((fp = fopen(filename, "w")) == NULL) /* եΥץ */
      return -1;

   fprintf(fp, "P6\n");	/* ޥåʥС */
   fprintf(fp, "# generated by ppmutil.c\n");	/*  */
   fprintf(fp, "%d %d\n", width, height);	/*  */
   fprintf(fp, "255\n");		/* ٥ */

   for (x = 0; x < width * height * 3; x++)
      fputc((0x00ff & img[x]), fp);

   fclose(fp);
   return 0;
}

int
load_ppm_file(int **img, char *filename, int *width, int *height)
{
   FILE		*fp;
   char		buff[BUFSIZ], magic[BUFSIZ];
   int		maxlevel, x;

   fp = fopen(filename, "r");
   if (fp == NULL)
      return -1;

   fgets(buff, BUFSIZ, fp);
   sscanf(buff, "%s", magic);

   if (strncmp(magic, "P6", 2))
   {
      fprintf(stderr, "Error: %s is not raw ppm format!\n", filename);
      exit(1);
   }

   fgets(buff, BUFSIZ, fp);
   while (buff[0] == '#')
      fgets(buff, BUFSIZ, fp);

   sscanf(buff, "%d %d", width, height);

   fgets(buff, BUFSIZ, fp);
   while (buff[0] == '#')
      fgets(buff, BUFSIZ, fp);
   sscanf(buff, "%d", &maxlevel);

   (*img) = new int [(*width) * (*height) * 3];
   
   for (x = 0; x < (*width) * (*height) * 3; x++)
      (*img)[x] = 0x00ff & fgetc(fp);

   fclose(fp);

   return 0;
}

